module.exports = (ba, idx) ->
	ret = " ";
	if (idx > ba.Length)
		error = 1;
		return ret;

	len = ba[idx++];
	if (len < 2)
		error = 1;
		return ret;

	if ((ba[idx] & 0x80) == 0)
		idx++;
	switch (ba[idx+1] & 0x7f)
		when 1 then ret += "Unallocated (unassigned) number"; break;
		when 2 then ret += "No route to specified transit network"; break;
		when 3 then ret += "No route to destination"; break;
		when 6 then ret += "Channel Unacceptable"; break;
		when 7 then ret += "Call awarded and being delivered in an established channel"; break;
		when 16 then ret += "Normal call clearing"; break;
		when 17 then ret += "User busy"; break;
		when 18 then ret += "No user responding"; break;
		when 19 then ret += "No answer from user (user alerted)"; break;
		when 21 then ret += "Call Rejected"; break;
		when 22 then ret += "Number changed"; break;
		when 26 then ret += "Non selected user clearing"; break;
		when 27 then ret += "Destination out of order"; break;
		when 28 then ret += "Invalid number format"; break;
		when 29 then ret += "facility rejected"; break;
		when 30 then ret += "Response to status enquiry"; break;
		when 31 then ret += "Normal, unspecified"; break;
		when 34 then ret += "No circuit/channel available"; break;
		when 38 then ret += "Network out of order"; break;
		when 41 then ret += "Temporary failure"; break;
		when 42 then ret += "Switching equipment congestion"; break;
		when 43 then ret += "Access information discarded"; break;
		when 44 then ret += "Requested circuit/channel not available"; break;
		when 45 then ret += "Pre-empted"; break;
		when 47 then ret += "Resources unavailable, unspecified"; break;
		when 49 then ret += "Quality of service unavailable"; break;
		when 50 then ret += "Requested facility not subscribed"; break;
		when 52 then ret += "Outgoing calls barred"; break;
		when 54 then ret += "Incoming calls barred"; break;
		when 57 then ret += "Bearer capability not authorised"; break;
		when 58 then ret += "Bearer capability not presently available"; break;
		when 63 then ret += "Service or option not available, unspecified"; break;
		when 65 then ret += "Bearer capability not implemented"; break;
		when 66 then ret += "Channel type not implemented"; break;
		when 69 then ret += "Requested facility not implemented"; break;
		when 70 then ret += "Only restricted digital information bearer capability is available"; break;
		when 79 then ret += "Service or option not implemented, unspecified"; break;
		when 81 then ret += "Invalid call reference value"; break;
		when 82 then ret += "Identified channel does not exist"; break;
		when 83 then ret += "A suspended call exists, but this call identity does not"; break;
		when 84 then ret += "Call identity in use"; break;
		when 85 then ret += "No call suspended"; break;
		when 86 then ret += "Call having the requested call identity has been cleared"; break;
		when 88 then ret += "Incompatible destination"; break;
		when 91 then ret += "Invalid transit network selection"; break;
		when 95 then ret += "Invalid message, unspecified"; break;
		when 96 then ret += "Mandatory information element is missing"; break;
		when 97 then ret += "Message type nonexistent or not implemented"; break;
		when 98 then ret += "Message not compatible with call state or message type nonexistent or not implemented"; break;
		when 99 then ret += "Information element nonexistent or not implemented"; break;
		when 100 then ret += "Invalid information element contents"; break;
		when 101 then ret += "Message not compatible with call state"; break;
		when 102 then ret += "Recovery on timer expiry"; break;
		when 111 then ret += "Protocol error, unspecified"; break;
		when 127 then ret += "Interworking, unspecified"; break;
		else ret += "Unknown cause value"; break;
	if (((ba[idx + 1] & 0x7f) != 16) && ((ba[idx + 1] & 0x0e) != 0)) #// ignore common cases
		switch (ba[idx + 1] & 0x0f)
			when 2 then ret += ", Location: Public network serving local user"; break;
			when 3 then ret += ", Location: Transit network"; break;
			when 4 then ret += ", Location: Public network serving remote user"; break;
			when 5 then ret += ", Location: Private network serving remote user"; break;
			when 7 then ret += ", Location: International network"; break;
			when 10 then ret += ", Location: Network beyond interworking point"; break;

	return ret;
